
openapi: 3.0.0
info:
  description: "This is a API of Lilog to read and write data from the database to server the system's frontend."
  version: "1.0.0"
  title: "Lilog API Sale Customer Group Member"
  termsOfService: "http://swagger.io/terms/"
  contact:
    email: "quochieu.ipcoms@gmail.com"
  license:
    name: "Apache 2.0"
    url: "http://www.apache.org/licenses/LICENSE-2.0.html"

paths:
  /search:
    post:
      summary: "Get data from Sale.Customer.Group.Member with or without conditions"
      tags: 
        - Sale.Customer.Group.Member
      requestBody:
        content:
          application/json:
            schema:
                $ref: '#/components/schemas/Sale.Customer.Group.Member.Payload.Search'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Sale.Customer.Group.Member.Response.Search'

  /write:
    post:
      summary: "Write data to Sale.Customer.Group database"
      tags: 
        - Sale.Customer.Group.Member
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/Sale.Customer.Group.Member.Payload.Write'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                  $ref: '#/components/schemas/Sale.Customer.Group.Member.Response.Write'
  /execute:
    post:
      summary: "get search field from Sale.Customer.Group.Member database"
      tags: 
        - Sale.Customer.Group.Member
      requestBody:
        content:
          application/json:
            schema:
                $ref: '#/components/schemas/Sale.Customer.Group.Member.Payload.Execute'

      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                  $ref: '#/components/schemas/Sale.Customer.Group.Member.Response.Execute'

  /delete:
    post:
      summary: "delete data from Sale.Customer.Group.Member database"
      tags: 
        - Sale.Customer.Group.Member
      requestBody:
        content:
          application/json:
            schema:
                $ref: '#/components/schemas/Sale.Customer.Group.Member.Payload.Delete'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema: 
                $ref: '#/components/schemas/Sale.Customer.Group.Member.Response.Delete'   
components:
  schemas:
    Sale.Customer.Group.Member.Payload.Search:
      type: object
      properties:
        model:
          type: string
          default: "sale.customer.group.member"
        # needed to be implemented
        domains:
          type: array
          description: điều kiện trả về data của Sale.Customer.Group.Member, ở dưới dạng 2d Array có phần tử dưới dạng (điều kiện, toán tử, query)
          items: 
            oneOf:
            - type: string
              description: tìm kiếm với tên trên thanh tìm kiếm
              default: "|"
            - type: array
              description: điều kiện tìm kiếm
              items: 
                oneOf:
                  - type: string
                    description: điều kiện
                  - type: string
                    description: toán tử
                  - oneOf:
                      - type: string
                      - type: integer
                    description: nhập thông tin lọc
                    
              maxItems: 3
            default:  [
              [
              "wh_customer.id",
              ">",
              20]
            ]
        options:
          type: object
          properties:
            includes:
              type: array
              items:
                type: string
              default:
                [
                  "customer",
                  "customer_group"
                ]
            fields:
              type: array
              description: s
              items:
                type: string
              default:
                [
                  "*",
                  "customer.code",
                  "customer.name",
                  "customer_group.code",
                  "customer_group.name"
                ]
        page:
          type: integer
          description: chỉ dấu trang data cần hiện thị
          default: 1
        perpage:
          type: integer
          description: số lượng elements mỗi trang
          default: 20
    Sale.Customer.Group.Member.Response.Search:
      type: object
      properties:
        data: 
          type: array
          description: data của thành viên nhóm khách hàng module Bán hàng được trả về
          items:
            type: object
            properties: 
              customer:
                type: integer
                description: s
                default: 12897
              customer_group:
                type: integer
                description: tên nhóm khách hàng
                default: 2
              customer_code:
                type: string
                description: mã khách hàng
                default: "05016"
              customer_name:
                type: string
                description: tên khách hàng
                default: "Nguyễn Thị Mai Trang"
              customer_group_code:
                type: string
                description: Mã nhóm khách hàng
                default: "Nhóm 1"
              customer_group_name:
                type: string
                description: Tên nhóm khách hàng
                default: "Nhóm 1"
              updated_at:
                type: string
                description: thời gian cập nhật
                default: "2021-11-24T03:50:27.480Z"
              created_at:
                type: string
                description: thời gian tạo
                default: "2021-11-24T03:50:27.480Z"
        meta:
          type: object
          properties:
            page:
              type: integer
              description: chỉ mục trang
              default: 1
            pages:
              type: integer
              description: tổng số trang
              default: 1
            perpage:
              type: integer
              description: số phần tử mỗi trang
              default: 20
            total:
              type: integer
              description: tổng số phần tử
              default: 18
              
      # default:
      #   {
      #     "data": [
      #         {
      #       "id": 2,
      #       "code": "Nhóm 1",
      #       "name": "Nhóm 1",
      #       "updated_at": "2021-11-24T02:32:17.146Z",
      #       "created_at": "2021-11-24T02:32:17.146Z"
      #         }
      #         ],
      #     "meta": {
      #         "page": 1,
      #         "pages": 1,
      #         "perpage": 20,
      #         "total": 11
      #     }
      # }
    Sale.Customer.Group.Member.Payload.Write:
      type: object
      properties:
        model:
          type: string
          description: "gọi đến model thành viên nhóm khách hàng"
          default: "sale.customer.group.member"
        args:
          type: object
          properties:
            customer:
              type: integer
              description: s
              default: 13234
            customer_group:
              type: integer
              description: s
              default: 27
    Sale.Customer.Group.Member.Response.Write:
      type: object
      properties:
        ok:
         type: boolean
         description: s
         default: true
        message: 
          type: string
          description: s
          default: "Thành công!"
        result:
          type: object
          properties:
            id:
              type: integer
              description: s
            meta:
              type: object
              properties:
                row_count:
                  type: integer
                  description: s
                  default: 1
                is_update:
                  type: boolean
                  description: s
                  default: false
                changed: 
                  type: array
                  description: s
                  items:
                    type: string
                    default: 
            model: 
              type: string
              default: "sale.customer.group.member"
              description: s
    Sale.Customer.Group.Member.Payload.Delete:
      type: object
      description: s
      properties: 
        model: 
          type: string
          default: "sale.customer.group.member"
          description: s
        ids:
          type: array
          description: s
          items:
            type: object
            description: s
            properties:
              customer:
                type: integer
                description: s
                default: 12897
              customer_group:
                type: integer
                description: s
                default: 14 
              customer_code:
                type: string
                description: mã khách hàng
                default: "13212"
              customer_name:
                type: string
                description: tên khách hàng
                default: "Nguyễn Thị Mai Trang"
              customer_group_code:
                type: string
                description: Mã nhóm khách hàng
                default:  "vp"
              customer_group_name:
                type: string
                description: Tên nhóm khách hàng
                default: "van phong"
              updated_at:
                type: string
                description: thời gian cập nhật
                default: "2021-12-02T09:04:14.537Z"
              created_at:
                type: string
                description: thời gian tạo
                default: "2021-12-02T09:04:14.537Z"
              selected:
                type: boolean
                description: s
                default: true
    Sale.Customer.Group.Member.Response.Delete:
      type: object
      properties:
        ok:
         type: boolean
        message:
          type: string
          description: s
          default: "1 record deleted"
    Sale.Customer.Group.Member.Payload.Execute:
      type: object
      properties:
        model:
          type: string
          default: "sale.customer.group.member"
        method:
          type: string
          default: "get_fields"
        args:
          type: array
          items: 
            type: object
          description: s
          default: null
    Sale.Customer.Group.Member.Response.Execute:
      type: object
      properties: 
        ok:
         type: boolean
         description: s
         default: true
        message: 
          type: string
          description: s
          default: "Thành công!"
        result:
          type: array
          items: 
            type: object
            properties:
              name:
                type: string
                description: s
                default: "id"
              fullname:
                type: string
                description: s
                default: "sale_customer_group.id"
              label:
                type: string
                description: s
                default: "ID"        
              datatype:
                type: string
                description: s
                default: "serial" 
              relationship:
                type: string
                description: s
                default: "wh.customer"
              relationship_table:
                type: string
                description: s
                default: "name"
         